SystemOrganization addCategory: #'MC2-Repository-Network'!

MDError subclass: #MDNetError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repository-Network'!

MDNetError subclass: #MDPeerError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repository-Network'!

MDNetError subclass: #MDProtocolError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repository-Network'!

MDRepository subclass: #MDNetRepository
	instanceVariableNames: 'link'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repository-Network'!

!MDNetRepository class methodsFor: 'instance creation' stamp: 'cwp 1/20/2008 13:09'!
host: aString
	^ self link: (MDNetLink host: aString)! !

!MDNetRepository class methodsFor: 'instance creation' stamp: 'cwp 1/20/2008 12:27'!
host: aString port: anInteger
	^ self link: (MDNetLink host: aString port: anInteger)! !

!MDNetRepository class methodsFor: 'instance creation' stamp: 'cwp 10/18/2009 22:38'!
id: aHashstamp host: aString port: anInteger
	^ self id: aHashstamp link: (MDNetLink host: aString port: anInteger)! !

!MDNetRepository class methodsFor: 'instance creation' stamp: 'jf 1/8/2010 16:04'!
id: aHashstamp link: aLink
	^ self basicNew
		intializeWithId: aHashstamp link: aLink;
		yourself! !

!MDNetRepository class methodsFor: 'instance creation' stamp: 'cwp 10/18/2009 22:32'!
link: aLink
	^ self id: MDHashstamp new link: aLink! !

!MDNetRepository methodsFor: 'synchronization' stamp: 'cwp 5/22/2008 00:11'!
allHashstamps
	| result |
	result := self send: MDGetHashstamps new.
	result assertMessageIs: MDAllHashstamps.
	^ result hashstamps! !

!MDNetRepository methodsFor: 'public' stamp: 'jf 10/25/2008 13:39'!
close
	| bye |
	link isOpen ifTrue: [
		bye := link send: MDGoodbye new.
		link close.
		bye assertMessageIs: MDGoodbye ]! !

!MDNetRepository methodsFor: 'public' stamp: 'cwp 5/22/2008 00:11'!
get: aHashstamp
	| objects |
	objects := self getAll: (Set with: aHashstamp).
	^ objects isEmpty ifFalse: [objects anyOne]! !

!MDNetRepository methodsFor: 'public' stamp: 'cwp 5/22/2008 00:11'!
getAll: aCollection
	| result |
	result := self send: (MDGetObjects with: aCollection).
	result assertMessageIs: MDObjects.
	^ result objects! !

!MDNetRepository methodsFor: 'synchronization' stamp: 'cwp 1/8/2008 18:45'!
includes: aHashstamp
	^ (self get: aHashstamp) notNil! !

!MDNetRepository methodsFor: 'initialize-release' stamp: 'cwp 1/18/2010 21:57'!
intializeWithId: aHashstamp link: aLink
	self initializeWithId: aHashstamp.
	link := aLink.! !

!MDNetRepository methodsFor: 'accessing' stamp: 'cwp 10/21/2009 23:38'!
link: aLink
	link := aLink! !

!MDNetRepository methodsFor: 'accessing' stamp: 'cwp 1/21/2008 20:41'!
locator
	^ link locator! !

!MDNetRepository methodsFor: 'public' stamp: 'cwp 5/22/2008 00:11'!
memos
	| result |
	result := self send: MDGetMemos new.
	result assertMessageIs: MDMemos.
	^ result objects! !

!MDNetRepository methodsFor: 'public' stamp: 'cwp 5/31/2008 14:44'!
name
	^ link description! !

!MDNetRepository methodsFor: 'public' stamp: 'cwp 5/22/2008 00:11'!
put: anObject
	| result |
	result := self send: (MDPutObjects with: {anObject}). 
	result assertMessageIs: MDThankYou! !

!MDNetRepository methodsFor: 'public' stamp: 'cwp 5/22/2008 00:11'!
putAll: aCollection
	| request |
	request := self send: (MDOfferObjects withObjects: aCollection).
	request assertMessageIs: MDRequestObjects.
	request 
		filter: aCollection
		in: [:put | (self send: put) assertMessageIs: MDThankYou]
! !

!MDNetRepository methodsFor: 'public' stamp: 'cwp 5/22/2008 00:11'!
selectFrom: aCollection
	| request |
	request := self send: (MDOfferObjects with: aCollection).
	request assertMessageIs: MDRequestObjects.
	^ request hashstamps! !

!MDNetRepository methodsFor: 'private' stamp: 'cwp 5/22/2008 00:11'!
send: aMessage
	| result |
	link isOpen ifFalse:
		[link open.
		result := link send: MDHello new.
		result assertMessageIs: MDHello].
	result := link send: aMessage.
	result checkForError.
	^ result! !

!MDNetRepository methodsFor: 'private' stamp: 'jf 11/8/2009 18:39'!
setLink: aLink
	link := aLink! !

!MDNetRepository methodsFor: 'accessing' stamp: 'cwp 6/5/2008 21:46'!
update: properties
	super update: properties.
	^ self locator update: properties! !

MDObject subclass: #MDNetLink
	instanceVariableNames: 'locator stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repository-Network'!

!MDNetLink class methodsFor: 'as yet unclassified' stamp: 'cwp 1/20/2008 13:09'!
host: aString
	^ self locator: (MDNetLocator host: aString)! !

!MDNetLink class methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 21:40'!
host: aString port: anInteger
	^ self locator: (MDNetLocator host: aString port: anInteger)! !

!MDNetLink class methodsFor: 'as yet unclassified' stamp: 'cwp 1/9/2008 14:49'!
locator: aLocator
	^ self new setLocator: aLocator! !

!MDNetLink methodsFor: 'as yet unclassified' stamp: 'cwp 1/12/2008 12:38'!
close
	stream close.
	! !

!MDNetLink methodsFor: 'as yet unclassified' stamp: 'cwp 1/12/2008 13:04'!
description
	^ locator description! !

!MDNetLink methodsFor: 'as yet unclassified' stamp: 'cwp 1/12/2008 13:10'!
isOpen
	^ stream notNil and: [stream isConnected]! !

!MDNetLink methodsFor: 'as yet unclassified' stamp: 'cwp 1/9/2008 16:03'!
locator
	^ locator! !

!MDNetLink methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
open
	stream := locator createStream.
	! !

!MDNetLink methodsFor: 'as yet unclassified' stamp: 'cwp 1/20/2008 12:44'!
send: aMessage
	self isOpen ifFalse: [self error: 'Link is not open'].
	aMessage writeOn: stream.
	stream flush.
	^ MDNetMessage readFrom: stream! !

!MDNetLink methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
setLocator: aLocator
	locator := aLocator! !

MDObject subclass: #MDNetListener
	instanceVariableNames: 'repository port socket process'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repository-Network'!

!MDNetListener class methodsFor: 'instance creation' stamp: 'jf 1/8/2010 15:31'!
new
	self shouldNotImplement! !

!MDNetListener class methodsFor: 'instance creation' stamp: 'jf 1/8/2010 15:30'!
repository: aRepository startOn: anInteger
	| listener |
	listener := self basicNew initializeWithRepository: aRepository port: anInteger; yourself.
	listener start.
	^ listener! !

!MDNetListener methodsFor: 'initialization' stamp: 'jf 1/8/2010 15:30'!
initializeWithRepository: aRepository port: anInteger
	self initialize.
	repository := aRepository.
	port := anInteger.
	! !

!MDNetListener methodsFor: 'as yet unclassified' stamp: 'cwp 1/20/2008 12:23'!
name
	^ '[', repository description, ']'! !

!MDNetListener methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
run
	| connection |
	[socket isValid] whileTrue:
		[connection := socket waitForAcceptFor: 10 ifTimedOut: [nil].
		connection ifNotNil: [MDServerLink 
								serve: connection 
								repository: repository]]
			! !

!MDNetListener methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
start
	socket := Socket newTCP.
	socket listenOn: port backlogSize: 10.
	process := [self run] 
				forkAt: Processor systemBackgroundPriority  
				named: self name
	! !

!MDNetListener methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 23:09'!
stop
	socket closeAndDestroy! !

MDObject subclass: #MDNetLocator
	instanceVariableNames: 'host port'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repository-Network'!

!MDNetLocator class methodsFor: 'instance creation' stamp: 'cwp 1/18/2008 21:31'!
host: aString 
	^ self host: aString port: nil! !

!MDNetLocator class methodsFor: 'instance creation' stamp: 'jf 1/8/2010 15:42'!
host: aString port: anInteger
	^ self basicNew
		initializeWithHost: aString port: anInteger;
		yourself! !

!MDNetLocator class methodsFor: 'instance creation' stamp: 'jf 1/8/2010 15:42'!
new
	self shouldNotImplement! !

!MDNetLocator methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
createStream
	| class stream |
	class := Smalltalk at: #FastSocketStream ifAbsent: [Smalltalk at: #SocketStream].
	stream := class openConnectionToHostNamed: self host port: self port.
	stream binary.
	^ stream! !

!MDNetLocator methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 21:32'!
defaultPort
	^ 6101! !

!MDNetLocator methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 21:32'!
description
	^ String streamContents: 
		[:stream |
		stream nextPutAll: host.
		port ifNotNil:
			[stream 
				nextPut: $:; 
				print: port]]! !

!MDNetLocator methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 21:32'!
host
	^ host! !

!MDNetLocator methodsFor: 'initialization' stamp: 'jf 1/8/2010 15:36'!
initializeWithHost: aString port: anInteger
	self initialize.
	host := aString.
	port := anInteger! !

!MDNetLocator methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 21:32'!
port
	^ port ifNil: [self defaultPort]! !

!MDNetLocator methodsFor: 'as yet unclassified' stamp: 'cwp 6/5/2008 21:43'!
update: properties
	^ properties
		host: self host;
		port: self port;
		yourself! !

MDObject subclass: #MDNetMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repository-Network'!

MDNetMessage subclass: #MDEmptyMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repository-Network'!

!MDEmptyMessage class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:05'!
readContentsFrom: aStream
	^ self new! !

!MDEmptyMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:04'!
= other
	^ self species = other species! !

!MDEmptyMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:04'!
hash
	^ self species hash! !

MDEmptyMessage subclass: #MDGetHashstamps
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repository-Network'!

!MDGetHashstamps class methodsFor: 'as yet unclassified' stamp: 'cwp 1/8/2008 18:02'!
id
	^ 68! !

!MDGetHashstamps methodsFor: 'as yet unclassified' stamp: 'cwp 1/8/2008 18:42'!
handledBy: anObject
	^ anObject handleGetHashstamps: self! !

MDEmptyMessage subclass: #MDGetMemos
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repository-Network'!

!MDGetMemos class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:44'!
id
	^ 67! !

!MDGetMemos methodsFor: 'dispatch' stamp: 'cwp 1/4/2008 22:11'!
handledBy: anObject
	^ anObject handleGetMemos: self! !

MDNetMessage subclass: #MDErrorMessage
	instanceVariableNames: 'description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repository-Network'!

MDErrorMessage subclass: #MDAuthenticationFailed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repository-Network'!

!MDAuthenticationFailed class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:30'!
id
	^ 193! !

!MDErrorMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:26'!
= other
	^ self species = other species and: [self description = other description]! !

!MDErrorMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:54'!
checkForError
	MDPeerError signal: description! !

!MDErrorMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:29'!
description
	^ description! !

!MDErrorMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:27'!
hash
	^ description hash! !

!MDErrorMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:53'!
isError
	^ true! !

!MDErrorMessage methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
setContents: aString
	description := aString! !

!MDErrorMessage methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2009 21:46'!
writeContentsOn: aStream
	MDSerializer serialize: description on: aStream! !

MDErrorMessage subclass: #MDObjectNotFound
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repository-Network'!

!MDObjectNotFound class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:34'!
id
	^ 195! !

MDErrorMessage subclass: #MDProcessingError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repository-Network'!

MDErrorMessage subclass: #MDStorageFailed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repository-Network'!

!MDStorageFailed class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:34'!
id
	^ 196! !

MDErrorMessage subclass: #MDUnauthorized
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repository-Network'!

!MDUnauthorized class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:32'!
id
	^ 194! !

MDErrorMessage subclass: #MDUnrecognizedMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repository-Network'!

!MDUnrecognizedMessage class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:27'!
id
	^ 192! !

MDNetMessage subclass: #MDHashstampMessage
	instanceVariableNames: 'hashstamps'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repository-Network'!

MDHashstampMessage subclass: #MDAllHashstamps
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repository-Network'!

!MDAllHashstamps class methodsFor: 'as yet unclassified' stamp: 'cwp 1/8/2008 18:36'!
id
	^ 132! !

MDHashstampMessage subclass: #MDGetObjects
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repository-Network'!

!MDGetObjects class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:43'!
id
	^ 64! !

!MDGetObjects methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 21:28'!
handledBy: aService
	^ aService handleGet: self! !

!MDHashstampMessage methodsFor: 'comparing' stamp: 'cwp 1/4/2008 00:02'!
= other
	^ self species = other species and: [self hashstamps = other hashstamps]! !

!MDHashstampMessage methodsFor: 'comparing' stamp: 'cwp 1/4/2008 00:02'!
hash
	^ hashstamps hash! !

!MDHashstampMessage methodsFor: 'accessing' stamp: 'cwp 1/4/2008 00:02'!
hashstamps
	^ hashstamps! !

!MDHashstampMessage methodsFor: 'intialize-release' stamp: 'cwp 5/22/2008 00:11'!
setContents: aCollection
	hashstamps := aCollection asSet! !

!MDHashstampMessage methodsFor: 'writing' stamp: 'cwp 11/8/2009 21:46'!
writeContentsOn: aStream
	MDSerializer serialize: hashstamps on: aStream! !

MDHashstampMessage subclass: #MDOfferObjects
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repository-Network'!

!MDOfferObjects class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:43'!
id
	^ 65! !

!MDOfferObjects class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:14'!
withObjects: aCollection
	^ self with: (aCollection collect: [:ea | ea hashstamp])! !

!MDOfferObjects methodsFor: 'dispatch' stamp: 'cwp 1/4/2008 22:19'!
handledBy: anObject
	^ anObject handleOfferObjects: self! !

MDHashstampMessage subclass: #MDRequestObjects
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repository-Network'!

!MDRequestObjects class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:43'!
id
	^ 129! !

!MDRequestObjects methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
filter: aCollection in: aBlock
	| selected |
	selected := aCollection select: [:ea | hashstamps includes: ea hashstamp].
	selected isEmpty ifFalse: [aBlock value: (MDPutObjects with: selected)]! !

!MDRequestObjects methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 21:00'!
isRequestObjects
	^ true! !

!MDNetMessage class methodsFor: 'reading' stamp: 'cwp 1/3/2008 23:04'!
fromBytes: aByteArray
	^ self readFrom: aByteArray readStream! !

!MDNetMessage class methodsFor: 'reading' stamp: 'cwp 1/3/2008 23:15'!
id
	self subclassResponsibility! !

!MDNetMessage class methodsFor: 'testing' stamp: 'cwp 1/4/2008 00:17'!
isConcrete
	^ self class includesSelector: #id! !

!MDNetMessage class methodsFor: 'reading' stamp: 'cwp 1/4/2008 00:17'!
messageClassWithId: anInteger
	^ self allSubclasses 
		detect: [:ea | ea isConcrete and: [ea id = anInteger]]
		ifNone: [self messageIdNotFound: anInteger]! !

!MDNetMessage class methodsFor: 'reading' stamp: 'cwp 1/3/2008 23:58'!
messageClasses
	^ self allSubclasses select: [:ea | ea class includesSelector: #id]! !

!MDNetMessage class methodsFor: 'reading' stamp: 'cwp 1/3/2008 23:12'!
messageIdNotFound: id
	^ self error: 'Message ', id asString, ' not understood'! !

!MDNetMessage class methodsFor: 'reading' stamp: 'cwp 11/8/2009 21:46'!
readContentsFrom: aStream
	^ self with: (MDMaterializer materializeFrom: aStream)! !

!MDNetMessage class methodsFor: 'reading' stamp: 'cwp 5/22/2008 00:11'!
readFrom: aStream
	| class |
	class := self messageClassWithId: aStream next.
	^ class readContentsFrom: aStream! !

!MDNetMessage class methodsFor: 'instance creation' stamp: 'cwp 1/3/2008 23:23'!
with: aSet
	^ self new setContents: aSet! !

!MDNetMessage methodsFor: 'testing' stamp: 'cwp 1/4/2008 21:06'!
assertMessageIs: aClass
	(self isKindOf: aClass) ifFalse: [MDProtocolError signal]! !

!MDNetMessage methodsFor: 'writing' stamp: 'cwp 1/3/2008 23:05'!
bytes
	^ ByteArray streamContents: [:stream | self writeOn: stream]! !

!MDNetMessage methodsFor: 'testing' stamp: 'cwp 1/4/2008 19:54'!
checkForError
	! !

!MDNetMessage methodsFor: 'accessing' stamp: 'cwp 1/3/2008 23:15'!
id
	^ self class id! !

!MDNetMessage methodsFor: 'testing' stamp: 'cwp 1/4/2008 19:53'!
isError
	^ false! !

!MDNetMessage methodsFor: 'testing' stamp: 'cwp 1/4/2008 14:17'!
isGoodbye
	^ false! !

!MDNetMessage methodsFor: 'testing' stamp: 'cwp 1/4/2008 12:36'!
isHello
	^ false! !

!MDNetMessage methodsFor: 'testing' stamp: 'cwp 1/4/2008 14:24'!
isMemos
	^ false! !

!MDNetMessage methodsFor: 'testing' stamp: 'cwp 1/4/2008 12:39'!
isObjects
	^ false! !

!MDNetMessage methodsFor: 'testing' stamp: 'cwp 1/4/2008 21:01'!
isRequestObjects
	^ false! !

!MDNetMessage methodsFor: 'testing' stamp: 'cwp 1/4/2008 20:57'!
isThankYou
	^ false! !

!MDNetMessage methodsFor: 'intialize-release' stamp: 'cwp 1/3/2008 23:23'!
setContents: anObject
	self subclassResponsibility! !

!MDNetMessage methodsFor: 'writing' stamp: 'cwp 1/3/2008 23:32'!
writeContentsOn: aStream
	! !

!MDNetMessage methodsFor: 'writing' stamp: 'cwp 1/3/2008 23:08'!
writeOn: aStream
	aStream nextPut: self id.
	self writeContentsOn: aStream! !

MDNetMessage subclass: #MDObjectsMessage
	instanceVariableNames: 'objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repository-Network'!

MDObjectsMessage subclass: #MDMemos
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repository-Network'!

!MDMemos class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:45'!
id
	^ 131! !

!MDMemos methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 14:24'!
isMemos
	^ true! !

MDObjectsMessage subclass: #MDObjects
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repository-Network'!

!MDObjects class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:45'!
id
	^ 128! !

!MDObjects methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 12:39'!
isObjects
	^ true! !

!MDObjectsMessage class methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2009 21:47'!
readContentsFrom: aStream
	^ self with: (MDMaterializer materializeFrom: aStream)! !

!MDObjectsMessage methodsFor: 'comparing' stamp: 'cwp 1/3/2008 23:17'!
= other
	^ self species = other species
		and: [objects = other objects]! !

!MDObjectsMessage methodsFor: 'comparing' stamp: 'cwp 1/3/2008 23:17'!
hash
	^ objects hash! !

!MDObjectsMessage methodsFor: 'accessing' stamp: 'cwp 1/3/2008 23:17'!
objects
	^ objects! !

!MDObjectsMessage methodsFor: 'initialize-release' stamp: 'cwp 5/22/2008 00:11'!
setContents: aCollection
	objects := aCollection asSet! !

!MDObjectsMessage methodsFor: 'writing' stamp: 'cwp 11/8/2009 21:47'!
writeContentsOn: aStream
	MDSerializer serialize: objects on: aStream! !

MDObjectsMessage subclass: #MDPutObjects
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repository-Network'!

!MDPutObjects class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:44'!
id
	^ 66! !

!MDPutObjects methodsFor: 'dispatch' stamp: 'cwp 1/4/2008 22:16'!
handledBy: anObject
	^ anObject handlePutObjects: self! !

MDNetMessage subclass: #MDSalutationMessage
	instanceVariableNames: 'description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repository-Network'!

MDSalutationMessage subclass: #MDGoodbye
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repository-Network'!

!MDGoodbye class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:40'!
id
	^ 2! !

!MDGoodbye methodsFor: 'dispatch' stamp: 'cwp 1/4/2008 22:25'!
handledBy: anObject
	^ anObject handleGoodbye: anObject! !

!MDGoodbye methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 14:17'!
isGoodbye
	^ true! !

MDSalutationMessage subclass: #MDHello
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repository-Network'!

!MDHello class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:39'!
id
	^ 1! !

!MDHello methodsFor: 'dispatch' stamp: 'cwp 1/4/2008 22:08'!
handledBy: anObject
	^ anObject handleHello: self! !

!MDHello methodsFor: 'testing' stamp: 'cwp 1/4/2008 12:36'!
isHello
	^ true! !

!MDSalutationMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:39'!
= other
	^ self species = other species and: [self description = other description]! !

!MDSalutationMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/20/2008 12:32'!
defaultDescription
	^ NetNameResolver localHostName! !

!MDSalutationMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/20/2008 12:30'!
description
	^ description ifNil: [self defaultDescription]! !

!MDSalutationMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:39'!
hash
	^ description hash! !

!MDSalutationMessage methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
setContents: aString
	description := aString! !

!MDSalutationMessage methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2009 21:47'!
writeContentsOn: aStream
	MDSerializer serialize: self description on: aStream! !

MDNetMessage subclass: #MDThankYou
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repository-Network'!

!MDThankYou class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:44'!
id
	^ 130! !

!MDThankYou methodsFor: 'comparing' stamp: 'cwp 1/3/2008 23:52'!
= other
	^ self species = other species and: [self count = other count]! !

!MDThankYou methodsFor: 'accessing' stamp: 'cwp 1/3/2008 23:52'!
count
	^ count! !

!MDThankYou methodsFor: 'comparing' stamp: 'cwp 1/3/2008 23:52'!
hash
	^ count hash! !

!MDThankYou methodsFor: 'writing' stamp: 'cwp 1/4/2008 20:58'!
isThankYou
	^ true! !

!MDThankYou methodsFor: 'intialize-release' stamp: 'cwp 5/22/2008 00:11'!
setContents: anInteger
	count := anInteger! !

!MDThankYou methodsFor: 'writing' stamp: 'cwp 11/8/2009 21:49'!
writeContentsOn: aStream
	MDSerializer serialize: count on: aStream! !

MDObject subclass: #MDNetService
	instanceVariableNames: 'repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repository-Network'!

!MDNetService class methodsFor: 'instance creation' stamp: 'jf 1/8/2010 16:05'!
for: aRepository
	^ self basicNew
		initializeWithRepository: aRepository;
		yourself! !

!MDNetService class methodsFor: 'instance creation' stamp: 'jf 1/8/2010 16:05'!
new
	self shouldNotImplement! !

!MDNetService methodsFor: 'public' stamp: 'cwp 1/19/2008 01:32'!
description
	^ repository description! !

!MDNetService methodsFor: 'message handlers' stamp: 'cwp 1/4/2008 21:27'!
handleGet: message
	^ MDObjects with: (repository getAll: message hashstamps)! !

!MDNetService methodsFor: 'message handlers' stamp: 'cwp 1/8/2008 18:43'!
handleGetHashstamps: message
	^ MDAllHashstamps with: (repository allHashstamps)! !

!MDNetService methodsFor: 'message handlers' stamp: 'cwp 1/4/2008 22:12'!
handleGetMemos: message
	^ MDMemos with: (repository memos)! !

!MDNetService methodsFor: 'message handlers' stamp: 'cwp 1/4/2008 22:26'!
handleGoodbye: message
	^ MDGoodbye new! !

!MDNetService methodsFor: 'message handlers' stamp: 'cwp 1/4/2008 22:08'!
handleHello: message
	^ MDHello new! !

!MDNetService methodsFor: 'public' stamp: 'cwp 1/4/2008 22:43'!
handleMessage: aMessage
	^ [aMessage handledBy: self]
		on: Error
		do: [:err | MDProcessingError with: err description]! !

!MDNetService methodsFor: 'message handlers' stamp: 'cwp 5/22/2008 00:11'!
handleOfferObjects: message
	| wanted |
	wanted := repository selectFrom: message hashstamps.
	^ MDRequestObjects with: wanted! !

!MDNetService methodsFor: 'message handlers' stamp: 'cwp 1/4/2008 22:34'!
handlePutObjects: message

	^ 	[repository putAll: message objects.
		MDThankYou with: message objects size]
			on: Error
			do: [:err | MDStorageFailed with: err description]! !

!MDNetService methodsFor: 'initialize-release' stamp: 'jf 1/8/2010 16:04'!
initializeWithRepository: aRepository
	self initialize.
	repository := aRepository! !

MDObject subclass: #MDServerLink
	instanceVariableNames: 'stream service process'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repository-Network'!

!MDServerLink class methodsFor: 'instance creation' stamp: 'jf 1/8/2010 16:06'!
new
	self shouldNotImplement! !

!MDServerLink class methodsFor: 'instance creation' stamp: 'cwp 5/22/2008 00:11'!
serve: aSocket repository: aRepository
	| link |
	link := self socket: aSocket repository: aRepository.
	link start! !

!MDServerLink class methodsFor: 'instance creation' stamp: 'jf 1/8/2010 16:06'!
socket: aSocket repository: aRepository
	^ self basicNew
		initializeWithSocket: aSocket repository: aRepository;
		yourself! !

!MDServerLink methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
handleMessage
	|  request response |
	[request := MDNetMessage readFrom: stream]
		on: ConnectionClosed, ConnectionTimedOut 
		do: [:exception | ^ nil].
	response := service handleMessage: request.
	response writeOn: stream.
	stream flush.
	response isGoodbye ifTrue: [stream close]! !

!MDServerLink methodsFor: 'as yet unclassified' stamp: 'jf 1/8/2010 16:05'!
initializeWithSocket: aSocket repository: aRepository
	self initialize.
	stream := self streamClass on: aSocket.
	service := MDNetService for: aRepository.
	stream binary! !

!MDServerLink methodsFor: 'as yet unclassified' stamp: 'cwp 1/19/2008 01:32'!
name
	^ String streamContents:
		[:out |
		out 
			nextPutAll: stream socket remoteAddress asString;
			nextPutAll: '->';
			nextPutAll: service description]! !

!MDServerLink methodsFor: 'as yet unclassified' stamp: 'cwp 1/19/2008 01:16'!
run
	[stream isConnected] whileTrue: [self handleMessage]! !

!MDServerLink methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
start
	process := [self run] 
				forkAt: Processor highIOPriority 
				named: self name
! !

!MDServerLink methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 23:18'!
streamClass
	^ Smalltalk at: #FastSocketStream ifAbsent: [Smalltalk at: #SocketStream]! !
